
var gl;
var points = [];
var NumTimesToSubdivide = 5;
var angle = 57.5
var poids = 1

window.onload = function init()
{
    var canvas = document.getElementById( "gl-canvas" );
    
    gl = WebGLUtils.setupWebGL( canvas );
    if ( !gl ) { alert( "WebGL isn't available" ); }

    
    // Three Vertices
    
    var vertices = [
        vec2( -1, -1 ),
        vec2(  0,  1 ),
        vec2(  1, -1 )
    ];

    divideTriangle(vertices[0], vertices[1], vertices[2],
                     NumTimesToSubdivide);


    //
    //  Configure WebGL
    //
    gl.viewport( 0, 0, canvas.width, canvas.height );
    gl.clearColor( 1.0, 1.0, 1.0, 1.0 );
    
    //  Load shaders and initialize attribute buffers
    
    var program = initShaders( gl, "vertex-shader", "fragment-shader" );
    gl.useProgram( program );
    
    // locate vPosition in the shaders

    var vPosition = gl.getAttribLocation(program, "vPosition");

    // Load the data into the GPU

    var bufferId = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, bufferId);
    gl.bufferData(gl.ARRAY_BUFFER, flatten(points), gl.STATIC_DRAW);

    // Now render

    gl.enableVertexAttribArray(vPosition);  // activate vertex array for vPosition

    //    gl.bindBuffer(gl.ARRAY_BUFFER, bufferId); // select buffer to be used
    // The previous line is not necessary because the correct buffer is already selected

    gl.vertexAttribPointer(vPosition, 2, gl.FLOAT, false, 0, 0);  // define data format


    render();
};


function triangle(a, b, c) {
    points.push(a, b, c);
}

function divideTriangle(a, b, c, count) {

    var aa = []
    var bb = []
    var cc = []

    // check for end of recursion

    if (count === 0) {

        distancea = Math.sqrt(a[0] * a[0] + a[1] * a[1])
        distanceb = Math.sqrt(b[0] * b[0] + b[1] * b[1])
        distancec = Math.sqrt(c[0] * c[0] + c[1] * c[1])

        aa[0] = a[0] * Math.cos(distancea * radians(angle)) - a[1] * Math.sin(distancea*radians(angle))
        aa[1] = a[0] * Math.sin(distancea * radians(angle)) + a[1] * Math.cos(distancea*radians(angle))
        bb[0] = b[0] * Math.cos(distanceb * radians(angle)) - b[1] * Math.sin(distanceb*radians(angle))
        bb[1] = b[0] * Math.sin(distanceb * radians(angle)) + b[1] * Math.cos(distanceb*radians(angle))
        cc[0] = c[0] * Math.cos(distancec * radians(angle)) - c[1] * Math.sin(distancec*radians(angle))
        cc[1] = c[0] * Math.sin(distancec * radians(angle)) + c[1] * Math.cos(distancec*radians(angle))

        triangle(aa, bb, cc);
    }
    else {

        //bisect the sides

        var ab = mix(a, b, 0.5);
        var ac = mix(a, c, 0.5);
        var bc = mix(b, c, 0.5);

        --count;

        // three new triangles

        divideTriangle(a, ab, ac, count);
        divideTriangle(c, ac, bc, count);
        divideTriangle(b, bc, ab, count);
    }
}

function render() {
    gl.clear( gl.COLOR_BUFFER_BIT );
    gl.drawArrays( gl.TRIANGLES, 0, points.length );
}
