
var canvas;
var gl;
var program;

var projectionMatrix; 
var modelViewMatrix;
var InitialmodelViewMatrix;
var normalMatrix = mat3();  //--- create a 3X3 matrix that will affect normals

var instanceMatrix;

var modelViewMatrixLoc;
var normalMatrixLoc;

var viewangle = 110.0;
var increment = 5;
		
var vertices = [

    vec4( -0.5, -0.5,  0.5, 1.0 ),
    vec4( -0.5,  0.5,  0.5, 1.0 ),
    vec4( 0.5,  0.5,  0.5, 1.0 ),
    vec4( 0.5, -0.5,  0.5, 1.0 ),
    vec4( -0.5, -0.5, -0.5, 1.0 ),
    vec4( -0.5,  0.5, -0.5, 1.0 ),
    vec4( 0.5,  0.5, -0.5, 1.0 ),
    vec4( 0.5, -0.5, -0.5, 1.0 )
];


var time = 0;

var torsoHeight = 5.0;
var torsoWidth = 1.0;
var upperArmHeight = 3.0;
var lowerArmHeight = 2.0;
var upperArmWidth  = 0.5;
var lowerArmWidth  = 0.5;
var upperLegWidth  = 0.5;
var lowerLegWidth  = 0.5;
var lowerLegHeight = 2.0;
var upperLegHeight = 3.0;
var headHeight = 1.5;
var headWidth = 1.0;

var numNodes = 10;
var numAngles = 11;
var angle = 0;

var figureDisplacement = 0;

var numVertices = 24;

var stack = [];

var vBuffer;
var modelViewLoc;

var pointsArray = [];
var normalsArray = [];

var numVertices  = 36;

var lightPosition = vec4(20.0, 10.0, 20.0, 0.0 );
var lightAmbient = vec4(0.2, 0.2, 0.2, 1.0 );
var lightDiffuse = vec4( 1.0, 1.0, 1.0, 1.0 );
var lightSpecular = vec4( 1.0, 1.0, 1.0, 1.0 );

var materialAmbient = vec4( 1.0, 0.0, 1.0, 1.0 );
var materialDiffuse = vec4( 1.0, 0.8, 0.0, 1.0);
var materialSpecular = vec4( 1.0, 0.8, 0.0, 1.0 );
var materialShininess = 100.0;

var ambientProduct, diffuseProduct, specularProduct;

var projectionMatrixLoc;
var ambientProductLoc;
var diffuseProductLoc;
var specularProductLoc;
var shininessLoc;
var lightPositionLoc;


var torso_node,
	head_node,
	left_upper_arm_node,
	right_upper_arm_node,
	left_lower_arm_node,
	right_lower_arm_node,
	left_upper_leg_node,
	right_upper_leg_node,
	left_lower_arm_node,
	right_lower_arm_node;
	
//-------------------------------------------

function scale4(a, b, c) {
   var result = mat4();
   result[0][0] = a;
   result[1][1] = b;
   result[2][2] = c;
   return result;
}

//--------------------------------------------

class TreeNode {
  constructor(render) {
	this.x_rotation_angle = null;
	this.y_rotation_angle = null;
    this.transform = null;
	this.render = render;
    this.sibling = null;
	this.child = null;
    this.parent = null;
  }

  add_sibling(node) {
    this.sibling = node;
    if (node) {
      node.parent = this;
    }
  }

  add_child(node) {
    this.child = node;
    if (node) {
      node.parent = this;
    }
  }
}

function Create_Left_Child_Right_Sibling(){

	create_nodes();
	
	torso_node.add_sibling(null);
	torso_node.add_child(head_node);
	
	head_node.add_sibling(left_upper_arm_node);
	head_node.add_child(null);
	
	left_upper_arm_node.add_sibling(right_upper_arm_node);
	left_upper_arm_node.add_child(left_lower_arm_node);
	
	left_lower_arm_node.add_sibling(null);
	left_lower_arm_node.add_child(null);
	
	right_upper_arm_node.add_sibling(left_upper_leg_node);
	right_upper_arm_node.add_child(right_lower_arm_node);
	
	right_lower_arm_node.add_sibling(null);
	right_lower_arm_node.add_child(null);	

	left_upper_leg_node.add_sibling(right_upper_leg_node);
	left_upper_leg_node.add_child(left_lower_leg_node);
	
	left_lower_leg_node.add_sibling(null);
	left_lower_leg_node.add_child(null);

	right_upper_leg_node.add_sibling(null);
	right_upper_leg_node.add_child(right_lower_leg_node);
	
	right_lower_leg_node.add_sibling(null);
	right_lower_leg_node.add_child(null);
	
}


function create_nodes(){
    var m = mat4();

	torso_node = new TreeNode(torso);
	torso_node.y_rotation_angle = 0;
    m = rotate(torso_node.y_rotation_angle, 0, 1, 0 );
	torso_node.transform = m;
	
	head_node = new TreeNode(head);
	head_node.x_rotation_angle = 0;
	head_node.y_rotation_angle = 0;
	m = translate(0.0, torsoHeight+0.5*headHeight, 0.0);
	m = mult(m, rotate(head_node.x_rotation_angle, 1, 0, 0))
	m = mult(m, rotate(head_node.y_rotation_angle, 0, 1, 0));
    m = mult(m, translate(0.0, -0.5*headHeight, 0.0));
	head_node.transform = m;

	left_upper_arm_node = new TreeNode(leftUpperArm);
	left_upper_arm_node.x_rotation_angle = 0;
	m = translate(-(torsoWidth+upperArmWidth), 0.9*torsoHeight, 0.0);
	m = mult(m, rotate(left_upper_arm_node.x_rotation_angle, 1, 0, 0));
	left_upper_arm_node.transform = m;
	
	right_upper_arm_node = new TreeNode(rightUpperArm);
	right_upper_arm_node.x_rotation_angle = 0;
    m = translate(torsoWidth+upperArmWidth, 0.9*torsoHeight, 0.0);
	m = mult(m, rotate(right_upper_arm_node.x_rotation_angle, 1, 0, 0));
	right_upper_arm_node.transform = m;
	
	left_upper_leg_node = new TreeNode(leftUpperLeg);
	left_upper_leg_node.x_rotation_angle = 180;
    m = translate(-(torsoWidth+upperLegWidth), 0.1*upperLegHeight, 0.0);
	m = mult(m , rotate(left_upper_leg_node.x_rotation_angle, 1, 0, 0));
	left_upper_leg_node.transform = m;
	
	right_upper_leg_node = new TreeNode(rightUpperLeg);
	right_upper_leg_node.x_rotation_angle = 180;
    m = translate(torsoWidth+upperLegWidth, 0.1*upperLegHeight, 0.0);
	m = mult(m, rotate(right_upper_leg_node.x_rotation_angle, 1, 0, 0));
	right_upper_leg_node.transform = m;
	
	left_lower_arm_node = new TreeNode(leftLowerArm);
	left_lower_arm_node.x_rotation_angle = -90;
    m = translate(0.0, upperArmHeight, 0.0);
    m = mult(m, rotate(left_lower_arm_node.x_rotation_angle, 1, 0, 0));
	left_lower_arm_node.transform = m;
	
	right_lower_arm_node = new TreeNode(rightLowerArm);
	right_lower_arm_node.x_rotation_angle = -90;
    m = translate(0.0, upperArmHeight, 0.0);
    m = mult(m, rotate(right_lower_arm_node.x_rotation_angle, 1, 0, 0));
	right_lower_arm_node.transform = m;
	
	left_lower_leg_node = new TreeNode(leftLowerLeg);
	left_lower_leg_node.x_rotation_angle = 0;
    m = translate(0.0, upperLegHeight, 0.0);
    m = mult(m, rotate(left_lower_leg_node.x_rotation_angle, 1, 0, 0));
	left_lower_leg_node.transform = m;

	right_lower_leg_node = new TreeNode(rightLowerLeg);
	right_lower_leg_node.x_rotation_angle = 0;
    m = translate(0.0, upperLegHeight, 0.0);
    m = mult(m, rotate(right_lower_leg_node.x_rotation_angle, 1, 0, 0));
	right_lower_leg_node.transform = m;

}




function traverse_lists(node) {
   
   if(node == null) return; 
   stack.push(modelViewMatrix);
   modelViewMatrix = mult(modelViewMatrix, node.transform);
   node.render();
   if(node.child != null) traverse_lists(node.child); 
    modelViewMatrix = stack.pop();
   if(node.sibling != null) traverse_lists(node.sibling); 
}


function torso() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5*torsoHeight, 0.0) );
    instanceMatrix = mult(instanceMatrix, scale4( torsoWidth, torsoHeight, torsoWidth));
	
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function head() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));
   
    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * headHeight, 0.0 ));
	instanceMatrix = mult(instanceMatrix, scale4(headWidth, headHeight, headWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function leftUpperArm() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * upperArmHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(upperArmWidth, upperArmHeight, upperArmWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function leftLowerArm() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * lowerArmHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(lowerArmWidth, lowerArmHeight, lowerArmWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function rightUpperArm() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * upperArmHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(upperArmWidth, upperArmHeight, upperArmWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function rightLowerArm() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * lowerArmHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(lowerArmWidth, lowerArmHeight, lowerArmWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function  leftUpperLeg() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * upperLegHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(upperLegWidth, upperLegHeight, upperLegWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function leftLowerLeg() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));
    
    instanceMatrix = mult(modelViewMatrix, translate( 0.0, 0.5 * lowerLegHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(lowerLegWidth, lowerLegHeight, lowerLegWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function rightUpperLeg() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));
    
    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * upperLegHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(upperLegWidth, upperLegHeight, upperLegWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function rightLowerLeg() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * lowerLegHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(lowerLegWidth, lowerLegHeight, lowerLegWidth) )
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

	
	
function quad(a, b, c, d) {

     var t1 = subtract(vertices[b], vertices[a]);
     var t2 = subtract(vertices[c], vertices[b]);
     var normal = cross(t1, t2);
     var normal = vec3(normal);
     normal = normalize(normal);

     pointsArray.push(vertices[a]); 
     normalsArray.push(normal); 
     pointsArray.push(vertices[b]); 
     normalsArray.push(normal); 
     pointsArray.push(vertices[c]); 
     normalsArray.push(normal);   
     pointsArray.push(vertices[a]);  
     normalsArray.push(normal); 
     pointsArray.push(vertices[c]); 
     normalsArray.push(normal); 
     pointsArray.push(vertices[d]); 
     normalsArray.push(normal);    
}


function cube()
{
    quad( 1, 0, 3, 2 );
    quad( 2, 3, 7, 6 );
    quad( 3, 0, 4, 7 );
    quad( 6, 5, 1, 2 );
    quad( 4, 5, 6, 7 );
    quad( 5, 4, 0, 1 );
}


window.onload = function init() {

    canvas = document.getElementById( "gl-canvas" );
    
    gl = WebGLUtils.setupWebGL( canvas );
    if ( !gl ) { alert( "WebGL isn't available" ); }
    
    gl.viewport( 0, 0, canvas.width, canvas.height );
    gl.clearColor( 1.0, 1.0, 1.0, 1.0 );
    
	gl.enable(gl.DEPTH_TEST);
	
    //
    //  Load shaders and initialize attribute buffers
    //
    program = initShaders( gl, "vertex-shader", "fragment-shader");
    
    gl.useProgram( program);

    var vNormal = gl.getAttribLocation( program, "vNormal" );
    var vPosition = gl.getAttribLocation( program, "vPosition" );
	
    modelViewMatrixLoc = gl.getUniformLocation( program, "modelViewMatrix");
    normalMatrixLoc = gl.getUniformLocation( program, "normalMatrix");
    projectionMatrixLoc = gl.getUniformLocation( program, "projectionMatrix");
    ambientProductLoc = gl.getUniformLocation(program, "ambientProduct");
    diffuseProductLoc = gl.getUniformLocation(program, "diffuseProduct");
    specularProductLoc = gl.getUniformLocation(program, "specularProduct");
    shininessLoc = gl.getUniformLocation(program,  "shininess");
    lightPositionLoc = gl.getUniformLocation(program, "lightPosition");
	
    gl.enableVertexAttribArray( vNormal );
    gl.enableVertexAttribArray( vPosition );
    
    cube();

    var nBuffer = gl.createBuffer();
    gl.bindBuffer( gl.ARRAY_BUFFER, nBuffer );
    gl.bufferData( gl.ARRAY_BUFFER, flatten(normalsArray), gl.STATIC_DRAW );
    
    gl.bindBuffer( gl.ARRAY_BUFFER, nBuffer );  // not necessary here since the last bind() defines the correct buffer
    gl.vertexAttribPointer( vNormal, 3, gl.FLOAT, false, 0, 0 );

	
    vBuffer = gl.createBuffer();
    gl.bindBuffer( gl.ARRAY_BUFFER, vBuffer );
    gl.bufferData(gl.ARRAY_BUFFER, flatten(pointsArray), gl.STATIC_DRAW);
    
    gl.bindBuffer( gl.ARRAY_BUFFER, vBuffer );  // not necessary here since the last bind() defines the correct buffer
    gl.vertexAttribPointer( vPosition, 4, gl.FLOAT, false, 0, 0 );


    ambientProduct = mult(lightAmbient, materialAmbient);
    diffuseProduct = mult(lightDiffuse, materialDiffuse);
    specularProduct = mult(lightSpecular, materialSpecular);
	
	instanceMatrix = mat4();
    
    projectionMatrix = perspective(viewangle, 1.0, 0.1, 200);
    modelViewMatrix = mat4();
    modelViewMatrix = mult(translate(0.0, 0.0, -7.0), modelViewMatrix);
	InitialmodelViewMatrix = modelViewMatrix;
	
    gl.uniform4fv(lightPositionLoc, flatten(lightPosition));
        
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(modelViewMatrix) );
    gl.uniformMatrix4fv(projectionMatrixLoc, false, flatten(projectionMatrix) );
    gl.uniform4fv(ambientProductLoc, flatten(ambientProduct));
    gl.uniform4fv(diffuseProductLoc, flatten(diffuseProduct) );
    gl.uniform4fv(specularProductLoc, flatten(specularProduct) );	
    gl.uniform1f(shininessLoc, materialShininess);

	document.getElementById("slider0").onchange = function() {
		viewangle = event.srcElement.valueAsNumber;
		};
	document.getElementById("slider1").onchange = function() {
		increment = event.srcElement.valueAsNumber;
		};
		  
	Create_Left_Child_Right_Sibling();
	
    render();
}


var render = function() {

        gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
		projectionMatrix = perspective(viewangle, 1.0, 0.1, 200);
		gl.uniformMatrix4fv(projectionMatrixLoc, false, flatten(projectionMatrix) );

		time += increment;
		modelViewMatrix = InitialmodelViewMatrix;
		
		// POUR COMPRENDRE LE FONCTIONNEMENT DE CHAQUE MOUVEMENT, VOUS POUVEZ METTRE EN COMMENTAIRES
		// TOUTES LES SECTIONS "controle" ET ENSUITE RENDRE ACTIVE UNE SECTION PARTICULIERE
		// POUR OBSERVER L'EFFET

		
		// controle du deplacement vertical du personnage
		// le facteur 2 permet d'obtenir 2 fois la frequence d'oscillation d'une jambe
		verticalDisplacement =  0.5*Math.sin(2*time * Math.PI/180.);  // l'angle du sin doit etre en radians
		                 // verticalDisplacement oscillera donc entre 0.5 et -0.5 
		modelViewMatrix = mult(modelViewMatrix, translate(0, verticalDisplacement , 0));
		
		// controle de la rotation du torse
		torso_node.y_rotation_angle = 0.1*time;
	    m = rotate(torso_node.y_rotation_angle, 0, 1, 0 );
		torso_node.transform = m;
	
		// controle de la rotation de la tete
		head_node.y_rotation_angle = 30*Math.sin(time * Math.PI/180.);  // l'angle du sin doit etre en radians
				// head_node.y_rotation_angle oscillera donc entre +30 et -30 degres
		m = translate(0.0, torsoHeight+0.5*headHeight, 0.0);
		m = mult(m, rotate(head_node.x_rotation_angle, 1, 0, 0))
		m = mult(m, rotate(head_node.y_rotation_angle, 0, 1, 0));
		m = mult(m, translate(0.0, -0.5*headHeight, 0.0));
		head_node.transform = m;
		
		// controle de la rotation de la partie superieure de la jambe droite
		right_upper_leg_node.x_rotation_angle = -180 + 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit etre en radians
				// right_upper_leg_node.x_rotation_angle oscillera donc entre -180+45 et -180-45 degres
		m = translate(torsoWidth+upperLegWidth, 0.1*upperLegHeight, 0.0);
		m = mult(m, rotate(right_upper_leg_node.x_rotation_angle, 1, 0, 0));
		right_upper_leg_node.transform = m;

		// controle de la rotation de la partie inferieure de la jambe droite
		right_lower_leg_node.x_rotation_angle = 45 + 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit etre en radians
				// right_lower_leg_node.x_rotation_angle oscillera donc entre 45+45 et 45-45 degres
		m = translate(0.0, upperLegHeight, 0.0);
		m = mult(m, rotate(right_lower_leg_node.x_rotation_angle, 1, 0, 0));
		right_lower_leg_node.transform = m;

		// controle de la rotation de la partie superieure de la jambe gauche
		left_upper_leg_node.x_rotation_angle = -180 - 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit etre en radians
				// left_upper_leg_node.x_rotation_angle oscillera donc entre -180+45 et 180-45 degres
				//  (et sera dephase de 90 degres par rapport à la partie superieure de la jambe droite)
		m = translate(-(torsoWidth+upperLegWidth), 0.1*upperLegHeight, 0.0);
		m = mult(m , rotate(left_upper_leg_node.x_rotation_angle, 1, 0, 0));
		left_upper_leg_node.transform = m;

		// controle de la rotation de la partie inferieure de la jambe gauche
		left_lower_leg_node.x_rotation_angle = 45 - 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit etre en radians
				// left_lower_leg_node.x_rotation_angle oscillera donc entre 45+45 et 45-45 degres
				//  (et sera dephase de 90 degres par rapport à la partie inferieure de la jambe droite)
		m = translate(0.0, upperLegHeight, 0.0);
		m = mult(m, rotate(left_lower_leg_node.x_rotation_angle, 1, 0, 0));
		left_lower_leg_node.transform = m;
		
		// controle de la rotation de la partie superieure du bras droit
		right_upper_arm_node.x_rotation_angle = 180 - 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit etre en radians
				// right_upper_arm_node.x_rotation_angle oscillera donc entre 180+45 et 180-45 degres
		m = translate(torsoWidth+upperArmWidth, 0.9*torsoHeight, 0.0);
		m = mult(m, rotate(right_upper_arm_node.x_rotation_angle, 1, 0, 0));
		right_upper_arm_node.transform = m;
		// Note: l'angle de la partie inferieure du bras droit est constant => voir create_nodes().
		
		// controle de la rotation de la partie superieure du bras gauche
		left_upper_arm_node.x_rotation_angle = 180 + 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit etre en radians
				// left_upper_arm_node.x_rotation_angle oscillera donc entre 180+45 et 180-45 degres
				//  (et sera dephase de 90 degres par rapport à la partie superieure du bras droit)
		m = translate(-(torsoWidth+upperArmWidth), 0.9*torsoHeight, 0.0);
		m = mult(m, rotate(left_upper_arm_node.x_rotation_angle, 1, 0, 0));
		left_upper_arm_node.transform = m;
		// Note: l'angle de la partie inferieure du bras gauche est constant => voir create_nodes().
		

		traverse_lists(torso_node);
		
		// dessiner un plancher 
		var m = mat4();
		instanceMatrix = mult(m, translate(0.0, -4.75, -7 ));
		instanceMatrix = mult(instanceMatrix, rotate(0.1*time, 0.0, 1.0, 0.0 ));
		
		normalMatrix = extractNormalMatrix(instanceMatrix);
		gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));
		
		instanceMatrix = mult(instanceMatrix, scale4(5, 0.5, 5) );
		
		gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
		gl.drawArrays( gl.TRIANGLES, 0, numVertices );		
		
        requestAnimFrame(render);
}




function matrixinvert(matrix) {

    var result = mat3();

    var det = matrix[0][0] * (matrix[1][1] * matrix[2][2] - matrix[2][1] * matrix[1][2]) -
                 matrix[0][1] * (matrix[1][0] * matrix[2][2] - matrix[1][2] * matrix[2][0]) +
                 matrix[0][2] * (matrix[1][0] * matrix[2][1] - matrix[1][1] * matrix[2][0]);

    var invdet = 1 / det;

    // inverse of matrix m
    result[0][0] = (matrix[1][1] * matrix[2][2] - matrix[2][1] * matrix[1][2]) * invdet;
    result[0][1] = (matrix[0][2] * matrix[2][1] - matrix[0][1] * matrix[2][2]) * invdet;
    result[0][2] = (matrix[0][1] * matrix[1][2] - matrix[0][2] * matrix[1][1]) * invdet;
    result[1][0] = (matrix[1][2] * matrix[2][0] - matrix[1][0] * matrix[2][2]) * invdet;
    result[1][1] = (matrix[0][0] * matrix[2][2] - matrix[0][2] * matrix[2][0]) * invdet;
    result[1][2] = (matrix[1][0] * matrix[0][2] - matrix[0][0] * matrix[1][2]) * invdet;
    result[2][0] = (matrix[1][0] * matrix[2][1] - matrix[2][0] * matrix[1][1]) * invdet;
    result[2][1] = (matrix[2][0] * matrix[0][1] - matrix[0][0] * matrix[2][1]) * invdet;
    result[2][2] = (matrix[0][0] * matrix[1][1] - matrix[1][0] * matrix[0][1]) * invdet;

    return result;
}

function extractNormalMatrix(matrix) { // This function computes the transpose of the inverse of 
    // the upperleft part (3X3) of the modelview matrix (see http://www.lighthouse3d.com/tutorials/glsl-tutorial/the-normal-matrix/ )

    var result = mat3();
    var upperleft = mat3();
    var tmp = mat3();

    upperleft[0][0] = matrix[0][0];  // if no scaling is performed, one can simply use the upper left
    upperleft[1][0] = matrix[1][0];  // part (3X3) of the modelview matrix
    upperleft[2][0] = matrix[2][0];

    upperleft[0][1] = matrix[0][1];
    upperleft[1][1] = matrix[1][1];
    upperleft[2][1] = matrix[2][1];

    upperleft[0][2] = matrix[0][2];
    upperleft[1][2] = matrix[1][2];
    upperleft[2][2] = matrix[2][2];

    tmp = matrixinvert(upperleft);
    result = transpose(tmp);

    return result;
}