
var canvas;
var gl;
var program;

var projectionMatrix; 
var modelViewMatrix;
var InitialmodelViewMatrix;
var normalMatrix = mat3();  //--- create a 3X3 matrix that will affect normals

var instanceMatrix;

var modelViewMatrixLoc;
var normalMatrixLoc;

var viewangle = 110.0;
var increment = 5;
		
var vertices = [

    vec4( -0.5, -0.5,  0.5, 1.0 ),
    vec4( -0.5,  0.5,  0.5, 1.0 ),
    vec4( 0.5,  0.5,  0.5, 1.0 ),
    vec4( 0.5, -0.5,  0.5, 1.0 ),
    vec4( -0.5, -0.5, -0.5, 1.0 ),
    vec4( -0.5,  0.5, -0.5, 1.0 ),
    vec4( 0.5,  0.5, -0.5, 1.0 ),
    vec4( 0.5, -0.5, -0.5, 1.0 )
];


var torsoId = 0;
var headId  = 1;
var head1Id = 1;
var head2Id = 10;
var leftUpperArmId = 2;
var leftLowerArmId = 3;
var rightUpperArmId = 4;
var rightLowerArmId = 5;
var leftUpperLegId = 6;
var leftLowerLegId = 7;
var rightUpperLegId = 8;
var rightLowerLegId = 9;

var time = 0;

var torsoHeight = 5.0;
var torsoWidth = 1.0;
var upperArmHeight = 3.0;
var lowerArmHeight = 2.0;
var upperArmWidth  = 0.5;
var lowerArmWidth  = 0.5;
var upperLegWidth  = 0.5;
var lowerLegWidth  = 0.5;
var lowerLegHeight = 2.0;
var upperLegHeight = 3.0;
var headHeight = 1.5;
var headWidth = 1.0;

var numNodes = 10;
var numAngles = 11;
var angle = 0;

var theta = [0, 0, 0, -90, 0, -90, -180, 0, -180, 0, 0];
var figureDisplacement = 0;

var numVertices = 24;

var stack = [];

var figure = [];

for( var i=0; i<numNodes; i++) figure[i] = createNode(null, null, null, null);

var vBuffer;
var modelViewLoc;

var pointsArray = [];
var normalsArray = [];

var numVertices  = 36;

var lightPosition = vec4(20.0, 10.0, 20.0, 0.0 );
var lightAmbient = vec4(0.2, 0.2, 0.2, 1.0 );
var lightDiffuse = vec4( 1.0, 1.0, 1.0, 1.0 );
var lightSpecular = vec4( 1.0, 1.0, 1.0, 1.0 );

var materialAmbient = vec4( 1.0, 0.0, 1.0, 1.0 );
var materialDiffuse = vec4( 1.0, 0.8, 0.0, 1.0);
var materialSpecular = vec4( 1.0, 0.8, 0.0, 1.0 );
var materialShininess = 100.0;

var ambientProduct, diffuseProduct, specularProduct;

var projectionMatrixLoc;
var ambientProductLoc;
var diffuseProductLoc;
var specularProductLoc;
var shininessLoc;
var lightPositionLoc;

//-------------------------------------------

function scale4(a, b, c) {
   var result = mat4();
   result[0][0] = a;
   result[1][1] = b;
   result[2][2] = c;
   return result;
}

//--------------------------------------------


function createNode(transform, render, sibling, child){
    var node = {
    transform: transform,
    render: render,
    sibling: sibling,
    child: child,
    }
    return node;
}


function initNodes(Id) {

    var m = mat4();
    
    switch(Id) {
    
    case torsoId:
    
    m = rotate(theta[torsoId], 0, 1, 0 );
    figure[torsoId] = createNode( m, torso, null, headId );
    break;

    case headId: 
    case head1Id: 
    case head2Id:
    

    m = translate(0.0, torsoHeight+0.5*headHeight, 0.0);
	m = mult(m, rotate(theta[head1Id], 1, 0, 0))
	m = mult(m, rotate(theta[head2Id], 0, 1, 0));
    m = mult(m, translate(0.0, -0.5*headHeight, 0.0));
    figure[headId] = createNode( m, head, leftUpperArmId, null);
    break;
    
    
    case leftUpperArmId:
    
    m = translate(-(torsoWidth+upperArmWidth), 0.9*torsoHeight, 0.0);
	m = mult(m, rotate(theta[leftUpperArmId], 1, 0, 0));
    figure[leftUpperArmId] = createNode( m, leftUpperArm, rightUpperArmId, leftLowerArmId );
    break;

    case rightUpperArmId:
    
    m = translate(torsoWidth+upperArmWidth, 0.9*torsoHeight, 0.0);
	m = mult(m, rotate(theta[rightUpperArmId], 1, 0, 0));
    figure[rightUpperArmId] = createNode( m, rightUpperArm, leftUpperLegId, rightLowerArmId );
    break;
    
    case leftUpperLegId:
    
    m = translate(-(torsoWidth+upperLegWidth), 0.1*upperLegHeight, 0.0);
	m = mult(m , rotate(-theta[leftUpperLegId], 1, 0, 0));
    figure[leftUpperLegId] = createNode( m, leftUpperLeg, rightUpperLegId, leftLowerLegId );
    break;

    case rightUpperLegId:
    
    m = translate(torsoWidth+upperLegWidth, 0.1*upperLegHeight, 0.0);
	m = mult(m, rotate(-theta[rightUpperLegId], 1, 0, 0));
    figure[rightUpperLegId] = createNode( m, rightUpperLeg, null, rightLowerLegId );
    break;
    
    case leftLowerArmId:

    m = translate(0.0, upperArmHeight, 0.0);
    m = mult(m, rotate(theta[leftLowerArmId], 1, 0, 0));
    figure[leftLowerArmId] = createNode( m, leftLowerArm, null, null );
    break;
    
    case rightLowerArmId:

    m = translate(0.0, upperArmHeight, 0.0);
    m = mult(m, rotate(theta[rightLowerArmId], 1, 0, 0));
    figure[rightLowerArmId] = createNode( m, rightLowerArm, null, null );
    break;
    
    case leftLowerLegId:

    m = translate(0.0, upperLegHeight, 0.0);
    m = mult(m, rotate(theta[leftLowerLegId], 1, 0, 0));
    figure[leftLowerLegId] = createNode( m, leftLowerLeg, null, null );
    break;
    
    case rightLowerLegId:

    m = translate(0.0, upperLegHeight, 0.0);
    m = mult(m, rotate(theta[rightLowerLegId], 1, 0, 0));
    figure[rightLowerLegId] = createNode( m, rightLowerLeg, null, null );
    break;
    
    }

}

function traverse(Id) {
   
   if(Id == null) return; 
   stack.push(modelViewMatrix);
   modelViewMatrix = mult(modelViewMatrix, figure[Id].transform);
   figure[Id].render();
   if(figure[Id].child != null) traverse(figure[Id].child); 
    modelViewMatrix = stack.pop();
   if(figure[Id].sibling != null) traverse(figure[Id].sibling); 
}

function torso() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5*torsoHeight, 0.0) );
    instanceMatrix = mult(instanceMatrix, scale4( torsoWidth, torsoHeight, torsoWidth));
	
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function head() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));
   
    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * headHeight, 0.0 ));
	instanceMatrix = mult(instanceMatrix, scale4(headWidth, headHeight, headWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function leftUpperArm() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * upperArmHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(upperArmWidth, upperArmHeight, upperArmWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function leftLowerArm() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * lowerArmHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(lowerArmWidth, lowerArmHeight, lowerArmWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function rightUpperArm() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * upperArmHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(upperArmWidth, upperArmHeight, upperArmWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function rightLowerArm() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * lowerArmHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(lowerArmWidth, lowerArmHeight, lowerArmWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function  leftUpperLeg() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * upperLegHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(upperLegWidth, upperLegHeight, upperLegWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function leftLowerLeg() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));
    
    instanceMatrix = mult(modelViewMatrix, translate( 0.0, 0.5 * lowerLegHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(lowerLegWidth, lowerLegHeight, lowerLegWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function rightUpperLeg() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));
    
    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * upperLegHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(upperLegWidth, upperLegHeight, upperLegWidth) );
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

function rightLowerLeg() {

    normalMatrix = extractNormalMatrix(modelViewMatrix);
    gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));

    instanceMatrix = mult(modelViewMatrix, translate(0.0, 0.5 * lowerLegHeight, 0.0) );
	instanceMatrix = mult(instanceMatrix, scale4(lowerLegWidth, lowerLegHeight, lowerLegWidth) )
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
    gl.drawArrays( gl.TRIANGLES, 0, numVertices );
}

	
	
function quad(a, b, c, d) {

     var t1 = subtract(vertices[b], vertices[a]);
     var t2 = subtract(vertices[c], vertices[b]);
     var normal = cross(t1, t2);
     var normal = vec3(normal);
     normal = normalize(normal);

     pointsArray.push(vertices[a]); 
     normalsArray.push(normal); 
     pointsArray.push(vertices[b]); 
     normalsArray.push(normal); 
     pointsArray.push(vertices[c]); 
     normalsArray.push(normal);   
     pointsArray.push(vertices[a]);  
     normalsArray.push(normal); 
     pointsArray.push(vertices[c]); 
     normalsArray.push(normal); 
     pointsArray.push(vertices[d]); 
     normalsArray.push(normal);    
}


function cube()
{
    quad( 1, 0, 3, 2 );
    quad( 2, 3, 7, 6 );
    quad( 3, 0, 4, 7 );
    quad( 6, 5, 1, 2 );
    quad( 4, 5, 6, 7 );
    quad( 5, 4, 0, 1 );
}


window.onload = function init() {

    canvas = document.getElementById( "gl-canvas" );
    
    gl = WebGLUtils.setupWebGL( canvas );
    if ( !gl ) { alert( "WebGL isn't available" ); }
    
    gl.viewport( 0, 0, canvas.width, canvas.height );
    gl.clearColor( 1.0, 1.0, 1.0, 1.0 );
    
	gl.enable(gl.DEPTH_TEST);
	
    //
    //  Load shaders and initialize attribute buffers
    //
    program = initShaders( gl, "vertex-shader", "fragment-shader");
    
    gl.useProgram( program);

    var vNormal = gl.getAttribLocation( program, "vNormal" );
    var vPosition = gl.getAttribLocation( program, "vPosition" );
	
    modelViewMatrixLoc = gl.getUniformLocation( program, "modelViewMatrix");
    normalMatrixLoc = gl.getUniformLocation( program, "normalMatrix");
    projectionMatrixLoc = gl.getUniformLocation( program, "projectionMatrix");
    ambientProductLoc = gl.getUniformLocation(program, "ambientProduct");
    diffuseProductLoc = gl.getUniformLocation(program, "diffuseProduct");
    specularProductLoc = gl.getUniformLocation(program, "specularProduct");
    shininessLoc = gl.getUniformLocation(program,  "shininess");
    lightPositionLoc = gl.getUniformLocation(program, "lightPosition");
	
    gl.enableVertexAttribArray( vNormal );
    gl.enableVertexAttribArray( vPosition );
    
    cube();

    var nBuffer = gl.createBuffer();
    gl.bindBuffer( gl.ARRAY_BUFFER, nBuffer );
    gl.bufferData( gl.ARRAY_BUFFER, flatten(normalsArray), gl.STATIC_DRAW );
    
    gl.bindBuffer( gl.ARRAY_BUFFER, nBuffer );  // not necessary here since the last bind() defines the correct buffer
    gl.vertexAttribPointer( vNormal, 3, gl.FLOAT, false, 0, 0 );

	
    vBuffer = gl.createBuffer();
    gl.bindBuffer( gl.ARRAY_BUFFER, vBuffer );
    gl.bufferData(gl.ARRAY_BUFFER, flatten(pointsArray), gl.STATIC_DRAW);
    
    gl.bindBuffer( gl.ARRAY_BUFFER, vBuffer );  // not necessary here since the last bind() defines the correct buffer
    gl.vertexAttribPointer( vPosition, 4, gl.FLOAT, false, 0, 0 );


    ambientProduct = mult(lightAmbient, materialAmbient);
    diffuseProduct = mult(lightDiffuse, materialDiffuse);
    specularProduct = mult(lightSpecular, materialSpecular);
	
	instanceMatrix = mat4();
    
    projectionMatrix = perspective(viewangle, 1.0, 0.1, 200);
    modelViewMatrix = mat4();
    modelViewMatrix = mult(translate(0.0, 0.0, -7.0), modelViewMatrix);
	InitialmodelViewMatrix = modelViewMatrix;
	
    gl.uniform4fv(lightPositionLoc, flatten(lightPosition));
        
    gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(modelViewMatrix) );
    gl.uniformMatrix4fv(projectionMatrixLoc, false, flatten(projectionMatrix) );
    gl.uniform4fv(ambientProductLoc, flatten(ambientProduct));
    gl.uniform4fv(diffuseProductLoc, flatten(diffuseProduct) );
    gl.uniform4fv(specularProductLoc, flatten(specularProduct) );	
    gl.uniform1f(shininessLoc, materialShininess);

	document.getElementById("slider0").onchange = function() {
		viewangle = event.srcElement.valueAsNumber;
		};
	document.getElementById("slider1").onchange = function() {
		increment = event.srcElement.valueAsNumber;
		};
		
    for(i=0; i<numNodes; i++) initNodes(i);
    
    render();
}


var render = function() {

        gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
		projectionMatrix = perspective(viewangle, 1.0, 0.1, 200);
		gl.uniformMatrix4fv(projectionMatrixLoc, false, flatten(projectionMatrix) );

		time += increment;
		modelViewMatrix = InitialmodelViewMatrix;
		
		// POUR COMPRENDRE LE FONCTIONNEMENT DE CHAQUE MOUVEMENT, VOUS POUVEZ METTRE EN COMMENTAIRES
		// TOUTES LES SECTIONS "contrôle" ET ENSUITE RENDRE ACTIVE UNE SECTION PARTICULIÈRE
		// POUR OBSERVER L'EFFET

		
		// contrôle du déplacement vertical du personnage
        // le facteur 2 permet d'obtenir 2 fois la fréquence d'oscillation d'une jambe
		verticalDisplacement =  0.5*Math.sin(2*time * Math.PI/180.);  // l'angle du sin doit être en radians
		                 // verticalDisplacement oscillera donc entre 0.5 et -0.5 
		modelViewMatrix = mult(modelViewMatrix, translate(0, verticalDisplacement , 0));
		
		// contrôle de la rotation du torse
		theta[torsoId ] = 0.1*time;
        initNodes(torsoId);
		
		// contrôle de la rotation de la tête
		theta[head2Id] = 30*Math.sin(time * Math.PI/180.);  // l'angle du sin doit être en radians
		                 // theta[headId] oscillera donc entre +30 et -30 degrés
		initNodes(head2Id);
		
		// contrôle de la rotation de la partie supérieure de la jambe droite
		theta[rightUpperLegId] = 180 - 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit être en radians
				         // theta[rightUpperLegId] oscillera donc entre 180+45 et 180-45 degrés
		initNodes(rightUpperLegId);

		// contrôle de la rotation de la partie inférieure de la jambe droite
		theta[rightLowerLegId] = 45 + 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit être en radians
				         // theta[rightLowerLegId] oscillera donc entre 45+45 et 45-45 degrés
		initNodes(rightLowerLegId);

		// contrôle de la rotation de la partie supérieure de la jambe gauche
		theta[leftUpperLegId] = 180 + 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit être en radians
				         // theta[leftUpperLegId] oscillera donc entre 180+45 et 180-45 degrés
						//  (et sera déphasé de 90 degrés par rapport à la partie supérieure de la jambe droite)
		initNodes(leftUpperLegId);

		// contrôle de la rotation de la partie inférieure de la jambe gauche
		theta[leftLowerLegId] = 45 - 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit être en radians
				         // theta[leftLowerLegId] oscillera donc entre 45+45 et 45-45 degrés
						//  (et sera déphasé de 90 degrés par rapport à la partie inférieure de la jambe droite)
		initNodes(leftLowerLegId);
		
		// contrôle de la rotation de la partie supérieure du bras droit
		theta[rightUpperArmId] = 180 - 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit être en radians
				         // theta[rightUpperArmId] oscillera donc entre 180+45 et 180-45 degrés
		initNodes(rightUpperArmId);
		// Note: l'angle de la partie inférieure du bras droit est constant (voir vecteur theta[] au début du code).
		
		// contrôle de la rotation de la partie supérieure du bras gauche
		theta[leftUpperArmId] = 180 + 45*Math.sin(time * Math.PI/180.);  // l'angle du sin doit être en radians
				         // theta[leftUpperArmId] oscillera donc entre 180+45 et 180-45 degrés
						//  (et sera déphasé de 90 degrés par rapport à la partie supérieure du bras droit)
		initNodes(leftUpperArmId);
		// Note: l'angle de la partie inférieure du bras gauche est constant (voir vecteur theta[] au début du code).
		
        traverse(torsoId);
		
		// dessiner un plancher 
		var m = mat4();
		instanceMatrix = mult(m, translate(0.0, -4.75, -7 ));
		instanceMatrix = mult(instanceMatrix, rotate(0.1*time, 0.0, 1.0, 0.0 ));
		
		normalMatrix = extractNormalMatrix(instanceMatrix);
		gl.uniformMatrix3fv(normalMatrixLoc, false, flatten(normalMatrix));
		
		instanceMatrix = mult(instanceMatrix, scale4(5, 0.5, 5) );
		
		gl.uniformMatrix4fv(modelViewMatrixLoc, false, flatten(instanceMatrix));
		gl.drawArrays( gl.TRIANGLES, 0, numVertices );		
		
        requestAnimFrame(render);
}




function matrixinvert(matrix) {

    var result = mat3();

    var det = matrix[0][0] * (matrix[1][1] * matrix[2][2] - matrix[2][1] * matrix[1][2]) -
                 matrix[0][1] * (matrix[1][0] * matrix[2][2] - matrix[1][2] * matrix[2][0]) +
                 matrix[0][2] * (matrix[1][0] * matrix[2][1] - matrix[1][1] * matrix[2][0]);

    var invdet = 1 / det;

    // inverse of matrix m
    result[0][0] = (matrix[1][1] * matrix[2][2] - matrix[2][1] * matrix[1][2]) * invdet;
    result[0][1] = (matrix[0][2] * matrix[2][1] - matrix[0][1] * matrix[2][2]) * invdet;
    result[0][2] = (matrix[0][1] * matrix[1][2] - matrix[0][2] * matrix[1][1]) * invdet;
    result[1][0] = (matrix[1][2] * matrix[2][0] - matrix[1][0] * matrix[2][2]) * invdet;
    result[1][1] = (matrix[0][0] * matrix[2][2] - matrix[0][2] * matrix[2][0]) * invdet;
    result[1][2] = (matrix[1][0] * matrix[0][2] - matrix[0][0] * matrix[1][2]) * invdet;
    result[2][0] = (matrix[1][0] * matrix[2][1] - matrix[2][0] * matrix[1][1]) * invdet;
    result[2][1] = (matrix[2][0] * matrix[0][1] - matrix[0][0] * matrix[2][1]) * invdet;
    result[2][2] = (matrix[0][0] * matrix[1][1] - matrix[1][0] * matrix[0][1]) * invdet;

    return result;
}

function extractNormalMatrix(matrix) { // This function computes the transpose of the inverse of 
    // the upperleft part (3X3) of the modelview matrix (see http://www.lighthouse3d.com/tutorials/glsl-tutorial/the-normal-matrix/ )

    var result = mat3();
    var upperleft = mat3();
    var tmp = mat3();

    upperleft[0][0] = matrix[0][0];  // if no scaling is performed, one can simply use the upper left
    upperleft[1][0] = matrix[1][0];  // part (3X3) of the modelview matrix
    upperleft[2][0] = matrix[2][0];

    upperleft[0][1] = matrix[0][1];
    upperleft[1][1] = matrix[1][1];
    upperleft[2][1] = matrix[2][1];

    upperleft[0][2] = matrix[0][2];
    upperleft[1][2] = matrix[1][2];
    upperleft[2][2] = matrix[2][2];

    tmp = matrixinvert(upperleft);
    result = transpose(tmp);

    return result;
}