

var canvas;
var gl;
var program;

var numVertices  = 6;

var ntextures_tobeloaded=0;
var ntextures_loaded=0;

//var flag = true;

var near = 0.3;
var far = 50.0;


var  fovy = 45.0;  // Field-of-view in Y direction angle (in degrees)
var  aspect = 1.0;       // Viewport aspect ratio


var texture1;
       
var pointsArray = [];
var colorsArray = [];
var texCoordsArray = [];

var texCoord = [
    vec2(0, 0),
    vec2(0, 1),
    vec2(1, 1),
    vec2(1, 0)
];


var vertices = [
    vec4( -5.5, -5.5,  0.0, 1.0 ),
    vec4( -5.5,  5.5,  0.0, 1.0 ),
    vec4( 5.5,   5.5,  0.0, 1.0 ),
    vec4( 5.5,  -5.5,  0.0, 1.0 ),
];

var modelViewMatrix, projectionMatrix;
var modelViewMatrixLoc, projectionMatrixLoc;


var vertexColors = [
    vec4( 0.0, 0.0, 0.0, 1.0 ),  // black
    vec4( 1.0, 1.0, 1.0, 1.0 ),  // white
    vec4( 1.0, 0.0, 0.0, 1.0 ),  // red
    vec4( 1.0, 1.0, 0.0, 1.0 ),  // yellow
    vec4( 0.0, 1.0, 0.0, 1.0 ),  // green
    vec4( 0.0, 0.0, 1.0, 1.0 ),  // blue
    vec4( 1.0, 0.0, 1.0, 1.0 ),  // magenta

    vec4( 0.0, 1.0, 1.0, 1.0 )   // cyan
];        
window.onload = init;



function handleLoadedTexture(texture) {
    gl.bindTexture(gl.TEXTURE_2D, texture);
    gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL, true);
    gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, texture.image);
	
	gl.generateMipmap( gl.TEXTURE_2D );
		
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);

	ntextures_loaded++;
	
    render();  // Call render function when the image has been loaded (to make sure the object is displayed)

	// Select the NULL texture (empty)
    gl.bindTexture(gl.TEXTURE_2D, null);
}


function initTexture() {
    texture1 = gl.createTexture();

    texture1.image = new Image();
    texture1.image.onload = function () {
        handleLoadedTexture(texture1)
    }

    texture1.image.src = "SA2011_black.gif";
	ntextures_tobeloaded++;
}

function quad(a, b, c, d) {

     pointsArray.push(vertices[a]); 
     colorsArray.push(vertexColors[1]); 
     texCoordsArray.push(texCoord[0]);

     pointsArray.push(vertices[b]); 
     colorsArray.push(vertexColors[1]);
     texCoordsArray.push(texCoord[1]); 

     pointsArray.push(vertices[c]); 
     colorsArray.push(vertexColors[1]);
     texCoordsArray.push(texCoord[2]); 
    
     pointsArray.push(vertices[a]); 
     colorsArray.push(vertexColors[1]);
     texCoordsArray.push(texCoord[0]); 

     pointsArray.push(vertices[c]); 
     colorsArray.push(vertexColors[1]);
     texCoordsArray.push(texCoord[2]); 

     pointsArray.push(vertices[d]); 
     colorsArray.push(vertexColors[1]);
     texCoordsArray.push(texCoord[3]); 
}


function init() {
    canvas = document.getElementById( "gl-canvas" );
    
    gl = WebGLUtils.setupWebGL( canvas );
    if ( !gl ) { alert( "WebGL isn't available" ); }

    gl.viewport( 0, 0, canvas.width, canvas.height );
    gl.clearColor( 0.5, 0.5, 0.5, 1.0 );

    //
    //  Load shaders and initialize attribute buffers
    //
    program = initShaders( gl, "vertex-shader", "fragment-shader" );
    gl.useProgram( program );
    
    quad( 0, 1, 2, 3 );

    var cBuffer = gl.createBuffer();
    gl.bindBuffer( gl.ARRAY_BUFFER, cBuffer);
    gl.bufferData( gl.ARRAY_BUFFER, flatten(colorsArray), gl.STATIC_DRAW );
    var vColorLoc = gl.getAttribLocation( program, "vColor" );
    gl.vertexAttribPointer(vColorLoc, 4, gl.FLOAT, false, 0, 0);
    gl.enableVertexAttribArray(vColorLoc);

    var vBuffer = gl.createBuffer();
    gl.bindBuffer( gl.ARRAY_BUFFER, vBuffer);
    gl.bufferData( gl.ARRAY_BUFFER, flatten(pointsArray), gl.STATIC_DRAW);
    var vPositionLoc = gl.getAttribLocation( program, "vPosition" );
    gl.vertexAttribPointer( vPositionLoc, 4, gl.FLOAT, false, 0, 0);
    gl.enableVertexAttribArray(vPositionLoc);
    
    var tBuffer = gl.createBuffer();
    gl.bindBuffer( gl.ARRAY_BUFFER, tBuffer);
    gl.bufferData( gl.ARRAY_BUFFER, flatten(texCoordsArray), gl.STATIC_DRAW );
    var vTexCoordLoc = gl.getAttribLocation( program, "vTexCoord");
    gl.vertexAttribPointer(vTexCoordLoc, 2, gl.FLOAT, false, 0, 0);
    gl.enableVertexAttribArray(vTexCoordLoc);

    initTexture();
    
    modelViewMatrixLoc = gl.getUniformLocation( program, "modelViewMatrix" );
    projectionMatrixLoc = gl.getUniformLocation( program, "projectionMatrix" );

// sliders for viewing parameters

    
        document.getElementById("Texture Style").onclick = function( event) {
          switch(event.srcElement.index) {
            case 0:
			   gl.bindTexture(gl.TEXTURE_2D, texture1);
               gl.texParameteri( gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, 
                   gl.NEAREST_MIPMAP_NEAREST);
               gl.texParameteri( gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, 
                    gl.NEAREST );
               break;
            case 1:
			   gl.bindTexture(gl.TEXTURE_2D, texture1);
               gl.texParameteri( gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, 
                    gl.NEAREST_MIPMAP_LINEAR);
               gl.texParameteri( gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER,
                    gl.LINEAR );
               break;
           case 2:
			   gl.bindTexture(gl.TEXTURE_2D, texture1);
			   gl.texParameteri( gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, 
                    gl.LINEAR_MIPMAP_NEAREST );
               gl.texParameteri( gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, 
                    gl.NEAREST );
               break;
            case 3:
			   gl.bindTexture(gl.TEXTURE_2D, texture1);
			   gl.texParameteri( gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, 
                    gl.LINEAR_MIPMAP_LINEAR );
               gl.texParameteri( gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, 
                    gl.LINEAR );
               break;
        };
	  render();
    };
       
	render();
}


var render = function() {
	
	if (ntextures_loaded == ntextures_tobeloaded) {  // if texture image has been loaded
	
		gl.clear( gl.COLOR_BUFFER_BIT);
		modelViewMatrix = translate(0.0, 0.0, -15.0);
		projectionMatrix = perspective(fovy, aspect, near, far);

		gl.uniformMatrix4fv( modelViewMatrixLoc, false, flatten(modelViewMatrix) );
		gl.uniformMatrix4fv( projectionMatrixLoc, false, flatten(projectionMatrix) );
	
		// Link loaded image to texture unit TEXTURE0 (in the GPU)
		gl.activeTexture(gl.TEXTURE0);
		gl.bindTexture(gl.TEXTURE_2D, texture1);
		
		// Send texture number to sampler
		gl.uniform1i(gl.getUniformLocation(program, "texture"), 0);
		
		gl.drawArrays( gl.TRIANGLES, 0, numVertices );
	}
}
